testiconv.c File Reference
`#include <stdio.h>`
`#include "SDL.h"`
Include dependency graph for testiconv.c:

Go to the source code of this file.

## Functions

static size_t | widelen (char *data)
int | main (int argc, char *argv[])

## Function Documentation

int main | ( | int | argc,
|  | char * | argv[]
| ) |  |

Definition at line 29 of file testiconv.c.

References formats, i, SDL_arraysize, SDL_free(), SDL_iconv_string, SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO, SDL_LogError, SDL_LogSetPriority, SDL_memcmp, SDL_strlen, and widelen().

{
const char *formats[] = {
"UTF8",
"UTF-8",
"UTF16BE",
"UTF-16BE",
"UTF16LE",
"UTF-16LE",
"UTF32BE",
"UTF-32BE",
"UTF32LE",
"UTF-32LE",
"UCS4",
"UCS-4",
};
char buffer[BUFSIZ];
char *ucs4;
char *test[2];
int i;
FILE *file;
int errors = 0;
/* Enable standard application logging */
SDL_LogSetPriority(SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO);
if (!argv[1]) {
argv[1] = "utf8.txt";
}
file = fopen(argv[1], "rb");
if (!file) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Unable to open %s\n", argv[1]);
return (1);
}
while (fgets(buffer, sizeof(buffer), file)) {
/* Convert to UCS-4 */
size_t len;
ucs4 =
SDL_iconv_string("UCS-4", "UTF-8", buffer,
SDL_strlen(buffer) + 1);
len = (widelen(ucs4) + 1) * 4;
for (i = 0; i < SDL_arraysize(formats); ++i) {
test[0] = SDL_iconv_string(formats[i], "UCS-4", ucs4, len);
test[1] = SDL_iconv_string("UCS-4", formats[i], test[0], len);
if (!test[1] || SDL_memcmp(test[1], ucs4, len) != 0) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "FAIL: %s\n", formats[i]);
++errors;
}
SDL_free(test[0]);
SDL_free(test[1]);
}
test[0] = SDL_iconv_string("UTF-8", "UCS-4", ucs4, len);
SDL_free(ucs4);
fputs(test[0], stdout);
SDL_free(test[0]);
}
fclose(file);
return (errors ? errors + 1 : 0);
}
formats
static SDL_PixelFormat * formats
Definition: SDL_pixels.c:485
widelen
static size_t widelen(char *data)
Definition: testiconv.c:18
len
GLenum GLsizei len
Definition: SDL_opengl_glext.h:2926
SDL_LogError
#define SDL_LogError
Definition: SDL_dynapi_overrides.h:42
SDL_free
void SDL_free(void *mem)
SDL_memcmp
#define SDL_memcmp
Definition: SDL_dynapi_overrides.h:395
SDL_LOG_PRIORITY_INFO
Definition: SDL_log.h:106
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:42
SDL_LogSetPriority
#define SDL_LogSetPriority
Definition: SDL_dynapi_overrides.h:242
SDL_strlen
#define SDL_strlen
Definition: SDL_dynapi_overrides.h:399
SDL_iconv_string
#define SDL_iconv_string
Definition: SDL_dynapi_overrides.h:447
buffer
GLuint buffer
Definition: SDL_opengl_glext.h:533
SDL_arraysize
#define SDL_arraysize(array)
Definition: SDL_stdinc.h:93
SDL_LOG_CATEGORY_APPLICATION
Definition: SDL_log.h:66

static size_t widelen | ( | char * | data | ) |

static

Definition at line 18 of file testiconv.c.

Referenced by main().

{
size_t len = 0;
Uint32 *p = (Uint32 *) data;
while (*p++) {
++len;
}
return len;
}
Uint32
uint32_t Uint32
An unsigned 32-bit integer type.
Definition: SDL_stdinc.h:155
p
GLfloat GLfloat p
Definition: SDL_opengl_glext.h:11090
data
GLint GLenum GLsizei GLsizei GLsizei GLint GLsizei const GLvoid * data
Definition: SDL_opengl.h:1967
len
GLenum GLsizei len
Definition: SDL_opengl_glext.h:2926